<!-- <h2 mat-dialog-title>{{tasks[0] ? tasks[0].name : 'Manage Tasks'}}</h2> -->
<h2 mat-dialog-title>Manage Tasks</h2>
<button [mat-dialog-close]="isDataChanged"
        mat-icon-button
        title="close"
        class="btn-icon-dialog-close">
  <mat-icon>close</mat-icon>
</button>
<div mat-dialog-content
     class="padding-0 app-tab">
  <mat-tab-group [(selectedIndex)]="selectedTabIndex">
    <mat-tab label="Task">
      <form autocomplete="off">
        <fieldset *ngFor="let taskCategory of taskCategories;let taskTypeIndex =index">
          <legend>{{taskCategory.name}}</legend>
          <table class="table-element-as-mat">
            <thead *ngIf="taskCategory.type === 'main'">
              <tr>
                <th class="col-task">Task Name</th>
                <th class="col-role">Role</th>
                <th class="col-assignee">Assignee</th>
                <th class="col-duration">Duration</th>
                <th>&nbsp;</th>
                <!--Delete button-->
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let element of taskCategory.tasks;let i =index">
                <td class="col-task">{{element.name}}</td>
                <td class="col-role">{{element.role}}</td>
                <td class="col-assignee">
                  <mat-form-field floatLabel="never"
                                  class="native-form-field">
                    <mat-select [(value)]="element.assignee"
                                [compareWith]="compareAssigneeFn"
                                (openedChange)="onAssigneePanelOpen($event, matSelectAssignee, taskCategory, element.role, 'existing', i)"
                                placeholder="Assignee"
                                #matSelectAssignee>
                      <ng-container *ngIf="canUseNormalAssigneeDropdown(taskCategory, element.role, 'existing', i); else loadingOption">
                        <mat-option [value]="item"
                                    *ngFor="let item of taskCategory.assignees[element.role] || (element.assignee && [element.assignee])">{{item.name}}</mat-option>
                      </ng-container>
                      <mat-option disabled
                                  style="display:none"></mat-option>
                    </mat-select>
                  </mat-form-field>
                  <button mat-button
                          type="button"
                          class="btn-round btn-blue-secondary"
                          (click)="setAssignee()">Set
                  </button>
                </td>
                <td class="col-duration">
                  <mat-form-field floatLabel="never"
                                  hideRequiredMarker
                                  class="native-form-field">
                    <!-- [ngModelOptions]="{standalone: true}" -->
                    <input matInput
                           #duration="ngModel"
                           name="duration{{i}}"
                           required
                           [(ngModel)]="element.duration"
                           [ngModelOptions]="{standalone: true}"
                           pattern="^[0-9][0-9]:[0-2][0-9]:[0-5][0-9]$"
                           placeholder="dd:hh:mm">
                    <!-- <mat-error *ngIf="duration.pattern?.invalid">dd:hh:mm only</mat-error> -->
                  </mat-form-field>
                  <button mat-button
                          type="button"
                          [disabled]="duration.invalid"
                          class="btn-round btn-blue-secondary"
                          (click)="setDuration()">Set
                  </button>
                </td>
                <td><button mat-icon-button
                          title="remove"
                          *ngIf="element.type!=='main'"
                          [disabled]="element.deleting"
                          (click)="delete(element, taskCategory.tasks)"
                          class="btn-icon-delete">
                    <mat-icon *ngIf="!element.deleting">delete</mat-icon>
                    <app-spinner button
                                 class="inline-spinner"
                                 *ngIf="element.deleting"></app-spinner>
                  </button></td>
              </tr>

              <!-- new row -->
              <tr [formGroup]="taskCategory.formGroup"
                  *ngIf="taskCategory.type !== 'main'">
                <td class="col-task">
                  <mat-form-field floatLabel="never"
                                  hideRequiredMarker
                                  class="native-form-field">
                    <input matInput
                           required
                           maxlength="50"
                           formControlName="name"
                           placeholder="New Task Name">
                  </mat-form-field>
                </td>
                <td class="col-role">
                  <mat-form-field floatLabel="never"
                                  hideRequiredMarker
                                  class="native-form-field">
                    <!-- <mat-select formControlName="role"
                                (selectionChange)="onRoleSelectionChange($event, taskCategory)" -->
                    <mat-select formControlName="role"
                                required
                                placeholder="Role">
                      <mat-option [value]="item"
                                  *ngFor="let item of taskCategory.roles">{{item}}</mat-option>
                    </mat-select>
                  </mat-form-field>
                </td>
                <td class="col-assignee">
                  <mat-form-field floatLabel="never"
                                  hideRequiredMarker
                                  class="native-form-field">
                    <mat-select formControlName="assignee"
                                required
                                placeholder="Assignee"
                                (openedChange)="onAssigneePanelOpen($event, matSelectAssignee, taskCategory, taskCategory.formGroup.controls.role.value, 'new', i)"
                                #matSelectAssignee>

                      <ng-container *ngIf="canUseNormalAssigneeDropdown(taskCategory, taskCategory.formGroup.controls.role.value, 'new'); else loadingOption">
                        <mat-option [value]="item"
                                    *ngFor="let item of taskCategory.assignees[taskCategory.formGroup.controls.role.value]">{{item.name}}</mat-option>
                      </ng-container>
                      <mat-option disabled
                                  style="display:none"></mat-option>
                    </mat-select>
                  </mat-form-field>
                  <button mat-button
                          type="submit"
                          class="btn-round btn-blue-secondary"
                          [disabled]="!taskCategory.formGroup.valid"
                          (click)="add(taskCategory)">Add
                  </button>
                </td>
                <td class="col-duration">&nbsp;</td>
                <td>&nbsp;</td>
              </tr>
            </tbody>
          </table>
        </fieldset>
      </form>

    </mat-tab>
    <mat-tab label="Document">
      <app-bpmn-document></app-bpmn-document>
    </mat-tab>
  </mat-tab-group>
</div>
<!-- <mat-dialog-actions *ngIf="selectedTabIndex === 0">
  <button mat-flat-button
          class="btn-round"
          (click)="save()"
          [disabled]="saving">Save<app-spinner button
                 class="inline-spinner"
                 *ngIf="saving"></app-spinner></button>
</mat-dialog-actions> -->
<ng-template #loadingOption>
  <mat-option disabled>
    <div class="container">
      <span>Loading...</span>
      <app-spinner button
                   class="inline-spinner"></app-spinner>
    </div>
  </mat-option>
</ng-template>
